from hpprime import *
from urandom import *
import sys

Mines     = 10
Width     = 9
Height    = 9
Board     = [[0]*Width]*Height
Uncovered = [[False]*Width]*Height
Flags     = [[True]*Width]*Height
NumFlag   = 10
CursorX   = 0
CursorY   = 0
OldCX     = 0
OldCY     = 0
level     = 1
StartTime = 0
Timer     = 0
Stop      = 0
StopTime  = 0


def updateMouse():
  global CursorX
  global CursorY
  global OldCX
  global OldCY
  c=eval('MOUSE()')[0]
  if len(c)==0:
    return
  c[0]=(c[0]+2**63)%2**64-2**63
  c[1]=(c[1]+2**63)%2**64-2**63
  #print(CursorX)
  if len(c)==0:
    return
  if c[4]==2:
    CursorX=max(0,min(320,CursorX-(OldCX-c[0])//2))
    CursorY=max(0,min(240,CursorY-(OldCY-c[1])//2))
    OldCX=c[0]
    OldCY=c[1]
  if c[4]<2: # new or completed action
    OldCX=c[0]
    OldCY=c[1]


def OpenSettings():
    global level
    global Width
    global Height
    global Mines
    level=eval('LOCAL level:={0};'.format(level)+'INPUT({{level,{"Beginner","Intermediate","Expert","Custom"}}},"Settings"); RETURN level;')
    #print(level)

    if level==4:
        Width,Height,Mines=(int(i) for i in eval('LOCAL Width:={0},Height:={1},Mines:={2};'.format(Width,Height,Mines)+'INPUT({Width,Height,Mines},"Custom Setup"); {Width,Height,Mines}'))
        while Width>30 or Height>19 or Width<8 or Height<1 or Mines>Width*Height-1:
            Width,Height,Mines=eval('LOCAL Width:={0},Height:={1},Mines:={2};'.format(Width,Height,Mines)+'INPUT({Width,Height,Mines},"Please Enter Valid Parameters!");Ans:={Width,Height,Mines};')

    Board=[[0]]
    Uncovered=[[0]]
    Flags=[[0]]
    init(level)


def matPlace(mat,y,x,val):
    templist=[]
    for i in range(Width):
        if i==x:
            templist.append(val)
        else:
            templist.append(mat[y][i])
    mat[y]=templist
    return mat


def Generate(SafeX,SafeY):
    global Height
    global Width
    global Board
    for i in range(Mines):

        Xpos=randint(0,Width-1)
        Ypos=randint(0,Height-1)

        #sys.exit(0)
        while Board[Ypos][Xpos]==10 or (Xpos==SafeX and Ypos==SafeY):
            #pass
            seed(int(eval('TICKS()')))
            Xpos=randint(0,Width-1)
            Ypos=randint(0,Height-1)
            #if Board[Ypos][Xpos]!=10:
              #break
        #print([i,Xpos,Ypos])
        #print(Board)

        #Board[Ypos][Xpos]=10
        #Board[Ypos].remove(Xpos)
        #Board[Ypos].insert(Xpos,10)
        Board=matPlace(Board,Ypos,Xpos,10)

    for i in range(Height):
        for j in range(Width):
            SurroundingMines=0
            if i>0:
                if j>0:
                    if Board[i-1][j-1]==10:
                        SurroundingMines+=1

                if Board[i-1][j]==10:
                    SurroundingMines+=1

                if j<Width-1:
                    if Board[i-1][j+1]==10:
                        SurroundingMines+=1

            if j>0:
                if Board[i][j-1]==10:
                    SurroundingMines+=1

            if j<Width-1:
                if Board[i][j+1]==10:
                    SurroundingMines+=1

            if i < Height-1:
                if j > 0:
                    if Board[i+1][j-1] == 10:
                        SurroundingMines += 1

                if Board[i+1][j] == 10:
                    SurroundingMines += 1

                if j < Width-1:
                    if Board[i+1][j+1] == 10:
                        SurroundingMines += 1

            if Board[i][j] != 10:
                Board[i][j] = SurroundingMines



def init(level):
    global Height
    global Width
    global Mines
    global Board
    global Uncovered
    global Flags
    global NumFlag

    if level==1:
        Height = 9
        Width = 9
        Mines = 10

    if level==2:
        Height = 16
        Width = 16 
        Mines = 40

    if level==3:
        Height = 16
        Width = 30
        Mines = 99

    Board = []
    Uncovered = []
    Flags = []
    for i in range(Height):
      Board.append([0]*Width)
      Uncovered.append([False]*Width)
      Flags.append([False]*Width)
    NumFlag = Mines



def Render(CX,CY,OX,OY,Mine,Face):
    global StartTime
    global Timer
    global Stop
    global StopTime
    #LOCAL MouseX,MouseY,UnitsDigit,TensDigit,HundredsDigit;

    fillrect(1,0,0,320,240,0x606060,0x606060)
    fillrect(1,0,0,10*Width+20,10*Height+50,0xc8c8c8,0xc8c8c8)

    #textout(1,160,120,str(1000*(int(eval('ticks'))-st)),0)

    line(1,0,0,10*Width+20,0,0xffffff)
    line(1,0,0,0,10*Height+49,0xffffff)
    line(1,1,1,10*Width+19,1,0xffffff)
    line(1,1,1,1,10*Height+48,0xffffff)
    line(1,10*Width+20,1,10*Width+20,10*Height+50,0x505050)
    line(1,0,10*Height+50,10*Width+20,10*Height+50,0x505050)
    line(1,10*Width+19,2,10*Width+19,10*Height+50,0x505050)
    line(1,1,10*Height+49,10*Width+20,10*Height+49,0x505050)

    line(1,8,8,10*Width+12,8,0x505050)
    line(1,8,8,8,30,0x505050)
    line(1,9,9,10*Width+11,9,0x505050)
    line(1,9,9,9,31,0x505050)
    line(1,10*Width+12,9,10*Width+12,32,0xffffff)
    line(1,8,32,10*Width+12,32,0xffffff)
    line(1,10*Width+11,10,10*Width+11,32,0xffffff)
    line(1,9,31,10*Width+12,31,0xffffff)

    line(1,9,39,10*Width+12,39,0x505050)
    line(1,9,39,9,10*Height+41,0x505050)
    line(1,10,40,10*Width+11,40,0x505050)
    line(1,10,40,10,10*Height+40,0x505050)
    line(1,10*Width+12,40,10*Width+12,10*Height+42,0xffffff)
    line(1,9,10*Height+42,10*Width+12,10*Height+42,0xffffff)
    line(1,10*Width+11,41,10*Width+11,10*Height+42,0xffffff)
    line(1,10,10*Height+41,10*Width+12,10*Height+41,0xffffff)
    #blit(0,0,0,1)
    #eval('blit_p(G1)')


    textout(1,1,1,"Settings",0x000000)

    dimgrob(5,10,10,0)
    eval('BLIT_P(G5,0,0,G2,0,23,10,33)')
    for i in range(Height):
        for j in range(Width):
            if Uncovered[i][j]:
                #//   DrawUncovered(J,I,Board[I,J]);
                strblit2(1,10*(j+1)+1,10*(i+1)+31,10,10,2,10*Board[i][j],13,10,10)
            else:
                blit(1,10*(j+1)+1,10*(i+1)+31,5)
                if Flags[i][j]:
                    eval('BLIT_P(G1,10*'+str(j+1)+'+1,10*'+str(i+1)+'+31,G2,10,23,20,33)')

    for i in range(Height):
        for j in range(Width):
            if Flags[i][j]==1:
                strblit2(1,10*(j+1)+1,10*(i+1)+31,10,10,2,10,23,10,10)

    if Mine==1:
        MouseX=int(OX/10)
        MouseY=int((OY-20)/10)
        for i in range(Height):
            for j in range(Width):
                if Board[i][j]==10 and Flags[i][j]==0:
                    strblit2(1,10*(j+1)+1,10*(i+1)+31,10,10,2,40,23,10,10)
                    if j==OX and i==OY:
                        strblit2(1,10*(j+1)+1,10*(i+1)+31,10,10,2,20,23,10,10)
                if Flags[i][j]==1 and Board[i][j]!=10:
                    strblit2(1,10*(j+1)+1,10*(i+1)+31,10,10,2,30,23,10,10)

    if Mine==2:
        MouseX=int(OX/10)+1
        MouseY=int((OY-20)/10)+1
        for i in range(Height):
           for j in range(Width):
                if Board[i][j]==10:
                    strblit2(1,10*(j+1)+1,10*(i+1)+31,10,10,2,10,23,10,10)

    strblit2(1,5*Width+1,12,17,17,2,17*Face,34,17,17)

    strblit2(1,17,14,8,13,2,8*(abs(NumFlag)//100),0,8,13)
    eval('BLIT_P(G1,17,14,G2,88*('+str(NumFlag)+'<0)-8,0,88*('+str(NumFlag)+'<0),13)')
    eval('BLIT_P(G1,25,14,G2,8*IP(('+str(abs(NumFlag))+'/10) MOD 10),0,8*IP(('+str(abs(NumFlag))+'/10) MOD 10)+8,13)')
    eval('BLIT_P(G1,33,14,G2,8*(ABS('+str(abs(NumFlag))+') MOD 10),0,8*(ABS('+str(abs(NumFlag))+') MOD 10)+8,13)')

    UnitsDigit      = int(eval('((TICKS-'+str(StartTime)+')/1000) MOD 10'))
    TensDigit      = int(eval('((TICKS-'+str(StartTime)+')/10000) MOD 10'))
    HundredsDigit = int(eval('((TICKS-'+str(StartTime)+')/100000) MOD 10'))

    if Timer==0:
        UnitsDigit=int(((StopTime/1000)) % 10)
        TensDigit=int(((StopTime)/10000) % 10)
        HundredsDigit=int(((StopTime)/100000) % 10)

    if int(UnitsDigit)==10:
        UnitsDigit=0
        TensDigit+=1

    if int(TensDigit)==10:
        TensDigit=0
        HundredsDigit+=1

    eval('BLIT_P(G1,10*'+str(Width)+'-21,14,G2,8*'+str(HundredsDigit)+',0,8*'+str(HundredsDigit)+'+9,13)')
    eval('BLIT_P(G1,10*'+str(Width)+'-13,14,G2,8*'+str(TensDigit)+',0,8*'+str(TensDigit)+'+9,13)')
    eval('BLIT_P(G1,10*'+str(Width)+'-5,14,G2,8*'+str(UnitsDigit)+',0,8*'+str(UnitsDigit)+'+9,13)')

    if CX<40 and CY<10:
        eval('BLIT_P(G1,'+str(CX)+'-4,'+str(CY)+',G4,0,0,10,12,#00FF00)')
    else:
        eval('BLIT_P(G1,'+str(CX)+','+str(CY)+',G3,0,0,10,12,#00FF00)')


    eval('BLIT_P(G1)')


def Dig2(Xps,Yps):
    global Uncovered
    global Width
    global Height
    global Flags
    global NumFlag
    if Xps<0 or Yps<0 or Xps>=Width or Yps>=Height or Uncovered[Yps][Xps]:
        return
    Uncovered[Yps][Xps]=True
    if Flags[Yps][Xps]:
        Flags[Yps][Xps]=False
        NumFlag+=1
    if Board[Yps][Xps]!=0:
        return
    for y in range(Yps-1,Yps+2):
        for x in range(Xps-1,Xps+2):
            try:
                Dig2(x,y)
            except RuntimeError:
                pass

def Dig(x,y):
  prevUncovered=[]
  while prevUncovered!=Board:
    prevUncovered=Board.copy()
    Dig2(x,y)


def Flag(X,Y):
    global NumFlag
    global Flags
    Flags=matPlace(Flags,Y,X,not Flags[Y][X]);

    NumFlag-=(1 if Flags[Y][X] else -1)

    while (keyboard()>>19)&1:
        pass

dimgrob(1,320,240,0)
eval('G2:=AFiles("textures.png")')
eval('G3:=AFiles("cursor.png")')
eval('G4:=AFiles("select.png")')

dimgrob(1,320,240,0)

Board=[[0]]
Uncovered=[[0]]
Flags=[[0]]

#LOCAL I,J,MouseX,MouseY,OldX,OldY,RemTiles,Won
CursorX=10
CursorY=10

while True:

    init(level);

    Render(CursorX,CursorY,0,0,0,0)

    StartTime=int(eval('TICKS'))
    Timer=0
    StopTime=0
    Render(CursorX,CursorY,0,0,0,0)

    while True:
        updateMouse()
        Render(CursorX,CursorY,0,0,0,0)
        #print(CursorX)
        StartTime=int(eval('TICKS'))

        X=int((CursorX-10)/10)
        Y=int((CursorY-40)/10)

        if eval('ISKEYDOWN(30)') and not (X>Width or Y>Height or X<0 or Y<0 or Flags[Y][X]):
            break
        if eval('ISKEYDOWN(19)') and not (X>Width or Y>Height or X*Y<0):
            Flag(X,Y)
            Render(CursorX,CursorY,0,0,0,0)

        if eval('ISKEYDOWN(30)') and CursorX<40 and CursorY<10:
            OpenSettings()

        if eval('ISKEYDOWN(30)') and not (CursorX>5*Width+18 or CursorY-40>20 or CursorX<5*Width+1 or CursorY<3):
            Render(CursorX,CursorY,0,0,0,1);
            while eval('ISKEYDOWN(30)'):
                pass

            Board=[[0]]
            Uncovered=[[0]]
            Flags=[[0]]
            init(level)
            Render(CursorX,CursorY,0,0,0,0);


            StartTime=int(eval('TICKS'))

    MouseX=int((CursorX-10)/10)
    MouseY=int((CursorY-40)/10)
    Generate(MouseX,MouseY)

    while True:

        while (keyboard()>>30)&1:
            Render(CursorX,CursorY,0,0,0,2)


        Dig(MouseX,MouseY)

        RemTiles=Width*Height
        for i in range(Height):
            for j in range(Width):
                if Uncovered[i][j]:
                    RemTiles-=1

        if RemTiles==Mines:
            Won=True
            break



        while True:

            Timer=1
            updateMouse()

            Render(CursorX,CursorY,0,0,0,0)

            X=int((CursorX-10)/10)
            Y=int((CursorY-40)/10)

            if (keyboard()>>30)&1 and not (X>Width or Y>Height or X<0 or Y<0 or Flags[Y][X]):
                break
            if eval('ISKEYDOWN(19)') and not (X>Width or Y>Height or X<0 or Y<0 or Uncovered[Y][X]):
                Flag(X,Y);
                Render(CursorX,CursorY,0,0,0,0); 

  
            if (keyboard()>>30)&1 and ((CursorX<40 and CursorY<10) or not (CursorX>5*Width+18 or CursorY-20>20 or CursorX<5*Width+1 or CursorY<3)):

                if CursorX<40 and CursorY<10:
                    OpenSettings()
                else:
                    Render(CursorX,CursorY,0,0,0,1)
                while eval('ISKEYDOWN(30)'):
                    pass

                Timer=0


                Board=[[0]]
                Uncovered=[[0]]
                Flags=[[0]]


                init(level)

                Render(CursorX,CursorY,0,0,0,0);

                while len(mouse()[0])==0:
                    pass
 
                while True:
                    updateMouse()
                    Render(CursorX,CursorY,0,0,0,0)

                    X=int((CursorX-10)/10);
                    Y=int((CursorY-40)/10);

                    if (keyboard()>>30)&1 and not (X>Width or Y>Height or X*Y<0 or Flags[Y][X]):break
                    if (keyboard()>>19)&1 and not (X>Width or Y>Height or X*Y<0 or Uncovered[Y][X]):
                        Flag(X,Y)
                        Render(CursorX,CursorY,0,0,0,0)

                    if (keyboard()>>30)&1 and CursorX<40 and CursorY<10:
                        OpenSettings()

                    StartTime=int(eval('ticks'))
                    if (keyboard()>>30)&1 and not (CursorX>5*Width+18 or CursorY-20>20 or CursorX<5*Width+1 or CursorY<3):

                        Render(CursorX,CursorY,0,0,0,1)
                        while (keyboard()>>30)&1:
                            pass

                        Board=[[0]]
                        Uncovered=[[0]]
                        Flags=[[0]]
                        init(level)
                        Render(CursorX,CursorY,0,0,0,0);

                MouseX=int(CursorX/10)+1
                MouseY=int((CursorY-20)/10)+1
                Generate(MouseX,MouseY)

        MouseX=int((CursorX-10)/10)
        MouseY=int((CursorY-40)/10)
 
        if Board[MouseY][MouseX]==10:
            Render(CursorX,CursorY,MouseX,MouseY,1,3)
            Won=0
            break

    while (keyboard()>>30)&1:
        pass

    Timer=0
    StopTime=int(eval('ticks'))-StartTime
    Render(CursorX,CursorY,MouseX,MouseY,1+Won,3+Won)

    if Won:NumFlag=0

    StartTime=int(eval('ticks'))
    Render(CursorX,CursorY,MouseX,MouseY,1+Won,3+Won);

    while True:

        updateMouse()
        Render(CursorX,CursorY,MouseX,MouseY,1+Won,3+Won);
        eval('AFiles("screenshot.png"):=G0')

        if (keyboard()>>30)&1 and not (CursorX>5*Width+18 or CursorY-20>20 or CursorX<5*Width+1 or CursorY<3):break

        StartTime=int(eval('ticks'))
 
        if (keyboard()>>30)&1 and CursorX<40 and CursorY<10:
            OpenSettings()
            break

    Render(CursorX,CursorY,MouseX,MouseY,1+Won,1);
    while (keyboard()>>30)&1:
        pass


    Board=[[0]]
    Uncovered=[[0]]
    Flags=[[0]]